module( "ULib3", package.seeall )

local function testTableContains()
	expectTrue( tableContains( { 'one val' }, 'one val' ) )
	expectTrue( tableContains( { true, 3 }, true ) )
	expectTrue( tableContains( { true, 3 }, 3 ) )
	expectFalse( tableContains( { true, 3 }, 4 ) )
	expectFalse( tableContains( { true, 3 }, false ) )
end
test( testTableContains, "tableContains", "basic" )

local function testTableContainsRecursion()
	local recursive = { 'someone', 'somewhere', 41, false }
	recursive.recursive = recursive -- recursive!
	
	expectTrue( tableContains( recursive, recursive, true ) )
	expectTrue( tableContains( recursive, 41, true ) )
	expectFalse( tableContains( recursive, 42, true ) )
	
	local recursiveb = { 'hidden' }
	local recursivec = { 'third' }
	recursiveb.next = recursivec
	recursiveb.parent = recrusive -- Just trying to throw more curveballs
	recursive.child = recursiveb
	
	expectTrue( tableContains( recursive, 'hidden', true ) )
	expectTrue( tableContains( recursive, 'third', true ) )
	expectTrue( tableContains( recursive, recursivec, true ) )
	expectFalse( tableContains( recursive, 'nope', true ) )
end
test( testTableContainsRecursion, "tableContains", "recursion" )

local function testSplitArgs()
	local str, expected
	
	str = 'This is a "fun sentence" "right charley?"'
	expected = { 'This', 'is', 'a', 'fun sentence', 'right charley?' }
	expectTablesEq( splitArgs( str ), expected )
	
	str = '"all one arg"'
	expected = { 'all one arg' }
	expectTablesEq( splitArgs( str ), expected )
	
	str = 'all split up'
	expected = { 'all', 'split', 'up' }
	expectTablesEq( splitArgs( str ), expected )
end
test( testSplitArgs, "splitArgs", "basic" )