if not ULib then
	ULib = {}

	Msg( "///////////////////////////////\n" )
	Msg( "//      Ulysses Library      //\n" )
	Msg( "///////////////////////////////\n" )
	Msg( "// Loading...                //\n" )

       	Msg( "//  shared/defines.lua       //\n" )
       	include( "ULib/shared/defines.lua" )
       	Msg( "//  shared/misc.lua          //\n" )
       	include( "ULib/shared/misc.lua" )
       	Msg( "//  shared/util.lua          //\n" )
       	include( "ULib/shared/util.lua" )
       	Msg( "//  shared/table.lua         //\n" )
       	include( "ULib/shared/tables.lua" )
       	Msg( "//  server/phys.lua          //\n" )
       	include( "ULib/server/phys.lua" )
       	Msg( "//  shared/player.lua        //\n" )
       	include( "ULib/shared/player.lua" )
       	Msg( "//  server/player.lua        //\n" )
       	include( "ULib/server/player.lua" )
       	Msg( "//  shared/sh_global.lua     //\n" )
       	include( "ULib/shared/sh_global.lua" )
       	Msg( "//  shared/messages.lua      //\n" )
       	include( "ULib/shared/messages.lua" )
       	Msg( "//  shared/concommand.lua    //\n" )
       	include( "ULib/shared/concommand.lua" )
       	Msg( "//  server/concommand.lua    //\n" )
       	include( "ULib/server/concommand.lua" )
       	Msg( "//  server/util.lua          //\n" )
       	include( "ULib/server/util.lua" )
       	Msg( "//  server/ucl.lua           //\n" )
       	include( "ULib/server/ucl.lua" )
	Msg( "// Load Complete!            //\n" )
	Msg( "///////////////////////////////\n" )

       	AddCSLuaFile( "ULib/cl_init.lua" )
	AddCSLuaFile( "ULib/shared/defines.lua" )
	AddCSLuaFile( "ULib/shared/misc.lua" )
	AddCSLuaFile( "ULib/shared/tables.lua" )
	AddCSLuaFile( "ULib/shared/sh_global.lua" )
	AddCSLuaFile( "ULib/client/cl_global.lua" )
	AddCSLuaFile( "ULib/shared/messages.lua" )
	AddCSLuaFile( "ULib/client/draw.lua" )
	AddCSLuaFile( "ULib/client/autocomplete.lua" )
	AddCSLuaFile( "ULib/client/util.lua" )
	AddCSLuaFile( "ULib/shared/player.lua" )
	AddCSLuaFile( "ULib/shared/util.lua" )
	AddCSLuaFile( "ULib/shared/concommand.lua" )	
	
	local files = file.FindInLua( "ULib/modules/*.lua" )
	if #files > 0 then
		for _, file in ipairs( files ) do
			print( "[ULIB] Loading module: " .. file )
			include( "ULib/modules/" .. file )
			AddCSLuaFile( "ULib/modules/" .. file )
		end
	end

	local function openULib( ply )
		local stat, err = pcall( ULib.sendLuaFunction, ply, "include", "ULib/cl_init.lua" )
		if not stat then
			ULib.console( ply, "There was an error trying to load ULib! Please Report this to the server admin! (" .. err .. ")" )
			Msg( "There was an error trying to load ULib for " .. ply:Nick() .. "! (" .. err .. ")\n" )
		end
		
		for _, file in ipairs( files ) do
			local stat, err = pcall( ULib.sendLuaFunction, ply, "include", "ULib/modules/" .. file )
			if not stat then
				ULib.console( ply, "There was an error trying to load a ULib module (" .. file .. ")! Please Report this to the server admin! (" .. err .. ")" )
				Msg( "There was an error trying to load a ULib module (" .. file .. ") for " .. ply:Nick() .. "! (" .. err .. ")\n" )
			end
		end
	end
	hook.Add( "PlayerInitialSpawn", "OpenULib", openULib )
end